package com.jiuqi.dna.ide.designer.policies;

import com.jiuqi.dna.ide.designer.commands.BendpointCreateCommand;
import com.jiuqi.dna.ide.designer.commands.BendpointDeleteCommand;
import com.jiuqi.dna.ide.designer.commands.BendpointMoveCommand;
import com.jiuqi.dna.ide.designer.elements.ILinkElement;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.BendpointEditPolicy;
import org.eclipse.gef.requests.BendpointRequest;

/* loaded from: com_jiuqi_dna_ide_designer_policies.jar:com/jiuqi/dna/ide/designer/policies/LinkBendpointEditPolicy.class */
public class LinkBendpointEditPolicy extends BendpointEditPolicy {
    protected Command getCreateBendpointCommand(BendpointRequest request) {
        Point p = request.getLocation();
        ILinkElement link = (ILinkElement) request.getSource().getModel();
        int index = request.getIndex();
        BendpointCreateCommand cmd = new BendpointCreateCommand(link, index, p);
        return cmd;
    }

    protected Command getDeleteBendpointCommand(BendpointRequest request) {
        Point p = request.getLocation();
        ILinkElement link = (ILinkElement) request.getSource().getModel();
        int index = request.getIndex();
        BendpointDeleteCommand cmd = new BendpointDeleteCommand(link, index, p);
        return cmd;
    }

    protected Command getMoveBendpointCommand(BendpointRequest request) {
        Point p = request.getLocation();
        ILinkElement link = (ILinkElement) request.getSource().getModel();
        int index = request.getIndex();
        BendpointMoveCommand cmd = new BendpointMoveCommand(link, index, p);
        return cmd;
    }
}
